CREATE OR REPLACE FUNCTION ARQUIVO_DCTF_R01_R02_R03 (
   P_CDLIVROMAG   IN LIVROMAGNETICO.CDLIVROMAG%TYPE,
   P_CDEMPRESA    IN EMPRESA.CDEMPRESA%TYPE,
   P_DTINICIAL    IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_DTFINAL      IN NOTAFISCAL.DTENTRSAID%TYPE,
   P_NRSEQARQMAG  IN ARQMAGNETICO.NRSEQARQMAG%TYPE,
   P_VERSAO       IN VARCHAR2,
   P_TPDECLARE    IN NOTAFISCAL.IDSTATUS%TYPE,
   P_NUMRECANT    IN VARCHAR2,
   P_SITUACAO     IN NOTAFISCAL.IDSTATUS%TYPE,
   P_NATJUR       IN NOTAFISCAL.IDSTATUS%TYPE,
   P_CDCONTADOR   IN NOTAFISCAL.IDSTATUS%TYPE,
   P_BALNCRED     IN NOTAFISCAL.IDSTATUS%TYPE,
   P_DBTOQTA      IN NOTAFISCAL.IDSTATUS%TYPE,
   P_TRIBLUC      IN NOTAFISCAL.IDSTATUS%TYPE,
   P_PJINATIVA    IN NOTAFISCAL.IDSTATUS%TYPE,
   P_PESJUR       IN NOTAFISCAL.IDSTATUS%TYPE,
   P_JAN          IN NOTAFISCAL.IDSTATUS%TYPE,
   P_FEV          IN NOTAFISCAL.IDSTATUS%TYPE,
   P_MAR          IN NOTAFISCAL.IDSTATUS%TYPE,
   P_ABR          IN NOTAFISCAL.IDSTATUS%TYPE,
   P_MAI          IN NOTAFISCAL.IDSTATUS%TYPE,
   P_JUN          IN NOTAFISCAL.IDSTATUS%TYPE,
   P_JUL          IN NOTAFISCAL.IDSTATUS%TYPE,
   P_AGO          IN NOTAFISCAL.IDSTATUS%TYPE,
   P_SET          IN NOTAFISCAL.IDSTATUS%TYPE,
   P_OUT          IN NOTAFISCAL.IDSTATUS%TYPE,
   P_NOV          IN NOTAFISCAL.IDSTATUS%TYPE,
   P_DEZ          IN NOTAFISCAL.IDSTATUS%TYPE,
   P_CRTESCRITUR  IN NOTAFISCAL.IDSTATUS%TYPE,
   P_REGAPUR      IN NOTAFISCAL.IDSTATUS%TYPE,
   P_PJBLC        IN NOTAFISCAL.IDSTATUS%TYPE,
   P_PJSCP        IN NOTAFISCAL.IDSTATUS%TYPE,
   P_PJINDT       IN NOTAFISCAL.IDSTATUS%TYPE,
   P_PJSEM        IN NOTAFISCAL.IDSTATUS%TYPE,
   P_PJMESDCLR    IN NOTAFISCAL.IDSTATUS%TYPE,
   P_PJCPRB       IN NOTAFISCAL.IDSTATUS%TYPE,
   P_SITUPJ       IN NOTAFISCAL.IDSTATUS%TYPE,
   P_STOPLEI      IN NOTAFISCAL.IDSTATUS%TYPE) RETURN NUMBER
AS
   V_CONTREGA      NUMBER;
   V_REG_HEADER VARCHAR2(1000);
   V_REG_R01    VARCHAR2(1000);
   V_REG_R02    VARCHAR2(1000);
   V_REG_R03    VARCHAR2(1000);
   V_CONTREGAR10   NUMBER;   
BEGIN
   V_REG_HEADER := '';
   V_REG_R01    := '';
   V_REG_R02    := '';
   V_REG_R03    := '';

   /*---------------------------HEADER----------------------------------*/
   SELECT ('DCTFM'                                                                                   ||
          RPAD(' ',3,' ')                                                                            ||/*RESERVADO*/
          RPAD(' ',4,' ')                                                                            ||/*RESERVADO*/
          TO_CHAR(P_DTINICIAL,'YYYY')                                                                ||/*ANO DE COMPETENCIA*/
          CASE WHEN P_VERSAO >= '340' THEN '1930' ELSE '0000' END                                    ||/*RESERVADO*/
          P_TPDECLARE                                                                                ||/*TIPO DE DECLARACAO*/
          LPAD(REPLACE(REPLACE(REPLACE(REPLACE(NRINSJUREMPR,'.',''),'-',''),'/',''),' ',''),14,0)    ||/*CNPJ*/
          '0'                                                                                        ||/*RESERVADO*/
          P_VERSAO                                                                                   ||/*VERSAO*/
          RPAD(NMRAZSOCEMPR,60,' ')                                                                  ||/*RAZAO SOCIAL*/
          RPAD(SGESTADO,2,' ')                                                                       ||/*ESTADO*/
          RPAD('0',10,'0')                                                                           ||/*RESERVADO*/
          '0'                                                                                        ||/*RESERVADO*/
          '0'||P_SITUACAO                                                                            ||/*SITUACAO*/
          TO_CHAR(P_DTINICIAL,'YYYY')                                                                ||/*ANO DE COMPETENCIA*/
          TO_CHAR(P_DTINICIAL,'MM')                                                                  ||/*MES DE COMPETENCIA*/
          RPAD('0',11,'0')                                                                           ||/*RESERVADO*/
          TO_CHAR(P_DTINICIAL,'DDMMYYYY')                                                            ||/*PERIODO BASE INICIAL*/
          TO_CHAR(P_DTFINAL,'DDMMYYYY')                                                              ||/*PERIODO BASE FINAL*/
          CASE WHEN P_SITUACAO = '0' THEN RPAD('0',8,'0') ELSE TO_CHAR(P_DTINICIAL,'DDMMYYYY')END    ||/*DATA DE OCORRENCIA DO EVENTO*/
          '0'                                                                                        ||/*RESERVADO*/
          '0'                                                                                        ||/*RESERVADO*/
          RPAD(' ',207,' ')                                                                          ||/*RESERVADO*/
          RPAD('0',10,'0')                                                                           )AS HEADER
     INTO V_REG_HEADER
     FROM EMPRESA
    WHERE CDEMPRESA = P_CDEMPRESA;
   V_CONTREGAR10 := NVL(V_CONTREGAR10,0) + 1;
   INSERT INTO ARQMAGNETICO
      (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
      ('00'||LPAD(RTRIM(V_CONTREGAR10), 8, '0'), V_REG_HEADER, P_NRSEQARQMAG);

   /*--------------------------------------REGISTRO R01------------------------------------------*/
   SELECT ((RPAD('R01',3,' '))                                                                         ||/*TIPO*/
          LPAD(REPLACE(REPLACE(REPLACE(REPLACE(NRINSJUREMPR,'.',''),'-',''),'/',''),' ',''),14,0)      ||/*CNPJ*/
          TO_CHAR(P_DTINICIAL,'YYYYMM')                                                                ||/*ANO E MES DE OCORRENCIA*/
          P_SITUACAO                                                                                   ||/*SITUACAO*/
          CASE WHEN P_SITUACAO = '0' THEN RPAD('0',8,'0') ELSE TO_CHAR(P_DTINICIAL,'YYYYMMDD')END      ||/*DATA DO EVENTO*/
          TO_CHAR(P_DTINICIAL,'DDMM')                                                                  ||/*INICIO DO PERIODO*/
          TO_CHAR(P_DTFINAL,'DDMM')                                                                    ||/*FIM DO PERIODO*/
          P_TPDECLARE                                                                                  ||/*TIPO DE DECLARACAO*/
          CASE WHEN P_TPDECLARE = '0' THEN RPAD('0',12,'0') ELSE P_NUMRECANT END                       ||/*RECIBO ANTERIOR*/
          P_TRIBLUC                                                                                    ||/*TRIBUTAO DO LUCRO*/
          P_PESJUR                                                                                     ||/*NATUREZA JURIDICA*/
          NVL(P_PJBLC,'0')                                                                             ||/*BALANCO DE SUSPENSAO*/
          NVL(P_PJSCP,'0')                                                                             ||/*DEBITO DE SCP*/
          CASE WHEN NVL(CDSITUCRT,'3') = '3' THEN 0 ELSE 1 END                                         ||/*EMPRESA OPTANTE PELO SIMPLES NACIONAL*/
          NVL(P_PJCPRB,'0')                                                                            ||/*PJ OPTANTE PELA CPRB*/
          P_PJINATIVA                                                                                  ||/*PJ INATIVA NO MS DA DECLARAO*/
          P_CRTESCRITUR                                                                                ||/*CRITERIO DE ESCRITURACAO - VARIAES DOS DIREITOS DE CRDITO */
          LPAD('0',11,'0')                                                                             ||/*RESERVADO*/
          NVL(P_REGAPUR,'0')                                                                           ||/*REGIME DE APURACAO*/
          NVL(P_SITUPJ,'0')                                                                            ||/*SITUAO DA PJ NO MS DA DECLARAO*/
          NVL(P_STOPLEI,'0')                                                                           ||/*OPES REFERENTES  LEI 12.973/2014 PARA O ANO-CALENDRIO DE 2014*/
          RPAD(' ',10,' ')                                                                             )AS REG_R01
     INTO V_REG_R01
     FROM EMPRESA E, PARAMEMPRESA P
    WHERE E.CDEMPRESA = P_CDEMPRESA
      AND E.CDEMPRESA = P.CDEMPRESA(+);
   V_CONTREGAR10 := NVL(V_CONTREGAR10,0) + 1;
   INSERT INTO ARQMAGNETICO
      (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
      ('01'||LPAD(RTRIM(V_CONTREGAR10), 8, '0'), V_REG_R01, P_NRSEQARQMAG);

   /*---------------------------------R02-----------------------------------*/
   SELECT ((RPAD('R02',3,' '))                                                                         ||/*TIPO*/
          LPAD(REPLACE(REPLACE(REPLACE(REPLACE(D.NRINSJUREMPR,'.',''),'-',''),'/',''),' ',''),14,0)    ||/*CNPJ*/
          TO_CHAR(P_DTINICIAL,'YYYYMM')                                                                ||/*ANO E MES DE OCORRENCIA*/
          P_SITUACAO                                                                                   ||/*SITUACAO*/
          CASE WHEN P_SITUACAO = '0' THEN RPAD('0',8,'0') ELSE TO_CHAR(P_DTINICIAL,'YYYYMMDD') END     ||/*DATA DO EVENTO*/
          RPAD(D.NMRAZSOCEMPR,115,' ')                                                                 ||/*RAZAO SOCIAL*/
          RPAD('0',4,'0')                                                                              ||/*RESERVADO*/
          RPAD(NVL(D.LOGRADOURO,' '),40,' ')                                                           ||/*LOGRADOURO*/
          RPAD(NVL(D.NUMERO,' '),6,' ')                                                                ||/*NMERO*/
          RPAD(NVL(D.DSCOMPENDEMP,' '),21,' ')                                                         ||/*COMPLEMENTO*/
          RPAD(NVL(D.NMBAIREMPR,' '),20,' ')                                                             ||/*BAIRRO*/
          RPAD(NVL(D.NMMUNICIPIO,' '),50,' ')                                                          ||/*MUNICIPIO*/
          RPAD(D.SGESTADO,2,' ')                                                                       ||/*ESTADO*/
          RPAD(NVL(REPLACE(REPLACE(D.NRCEPEMPR,'.'),'-'),' '),8,' ')                                   ||/*CEP*/
          LPAD(NVL(D.NRDDDTELEEMP,' '),4,' ')                                                          ||/*DDD*/
          LPAD(NVL(D.NRTELEEMPSEP,' '),9,' ')                                                          ||/*TELEFONE*/
          LPAD(NVL(D.NRDDDFAXEMP,' '),4,' ')                                                           ||/*DDD FAX*/
          LPAD(NVL(D.NRFAXEMPSEP,' '),9,' ')                                                           ||/*FAX*/
          RPAD(' ',6,' ')                                                                              ||/*CAIXA POSTAL*/
          RPAD(' ',2,' ')                                                                              ||/*UF DA CAIXA POSTAL*/
          RPAD(' ',8,' ')                                                                              ||/*CEP DA CAIXA POSTAL*/
          RPAD(NVL(D.DSEMAILEMPRESA,' '),40,' ')                                                       ||/*CORREIO ELETRONICO*/
          RPAD(' ',10,' ')                                                                             )AS REG_R02/*BRANCOS*/
     INTO V_REG_R02
     FROM (SELECT REPLACE(REPLACE(REPLACE(REPLACE(E.NRINSJUREMPR,'.',''),'-',''),'/',''),' ','') AS NRINSJUREMPR,
                  E.NMRAZSOCEMPR, --NVL(L.DSLOGRADOURO,SUBSTR(E.DSENDEEMPR,1,INSTR(E.DSENDEEMPR,' '))) AS LOGRADOURO,
                  NVL(L.DSLOGRADOURO||E.DSENDEEMPSEP,E.DSENDEEMPR) AS LOGRADOURO,
                  NVL(E.NRENDEEMPSEP,SUBSTR(E.DSENDEEMPR,INSTR(E.DSENDEEMPR,' ',-1)+1,LENGTH(E.DSENDEEMPR))) AS NUMERO,
                  E.DSCOMPENDEMP, M.NMMUNICIPIO, E.SGESTADO, E.NRCEPEMPR, E.NRTELEFOEMPR, E.DSEMAILEMPRESA, E.NMBAIREMPR,
                  E.NRDDDTELEEMP, E.NRTELEEMPSEP, E.NRDDDFAXEMP, E.NRFAXEMPSEP
             FROM EMPRESA E, MUNICIPIO M, LOGRADOURO L
            WHERE E.CDEMPRESA    = P_CDEMPRESA
              AND E.CDMUNICIPIO  = M.CDMUNICIPIO
              AND E.SGESTADO     = M.SGESTADO
              AND E.CDPAIS       = M.CDPAIS
              AND E.CDLOGRADOURO = L.CDLOGRADOURO(+))D;
   V_CONTREGAR10 := NVL(V_CONTREGAR10,0)+1;
   INSERT INTO ARQMAGNETICO
      (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
      ('02'||LPAD(RTRIM(V_CONTREGAR10), 8, '0'), V_REG_R02, P_NRSEQARQMAG);

   /*-----------------------------------R03------------------------------*/
   SELECT ((RPAD('R03',3,' '))                                                                         ||/*TIPO*/
          LPAD(REPLACE(REPLACE(REPLACE(REPLACE(E.NRINSJUREMPR,'.',''),'-',''),'/',''),' ',''),14,0)    ||/*CNPJ*/
          TO_CHAR(P_DTINICIAL,'YYYYMM')                                                                ||/*ANO E MES DE OCORRENCIA*/
          P_SITUACAO                                                                                   ||/*SITUACAO*/
          CASE WHEN P_SITUACAO = '0' THEN RPAD('0',8,'0') ELSE TO_CHAR(P_DTINICIAL,'YYYYMMDD') END     ||/*DATA DO EVENTO*/
          RPAD(L.NMREPRES,60,' ')                                                                      ||/*RESPONSAVEL*/
          LPAD(L.NRCPFREPRES,11,' ')                                                                   ||/*CPF*/
          LPAD(NVL(L.NRDDDTELEREPRES1,' '),4,' ')                                                      ||/*DDD*/
          LPAD(NVL(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(L.NRTELEREPRES1,'.',''),'-',''),'/',''),' ',''),')',''),'(',''),' '),9,' ')||/*TELEFONE*/
          LPAD(NVL(L.NRRAMALREPRES1,' '),5,' ')                                                        ||/*RAMAL*/
          LPAD(NVL(L.NRDDDFAXREPRES,' '),4,' ')                                                        ||/*DDD FAX*/
          LPAD(NVL(L.NRFAXREPRES,' '),9,' ')                                                           ||/*FAX*/
          RPAD(NVL(L.DSEMAILREPRES,' '),40,' ')                                                        ||/*CORREIO ELETRONICO REPRESENTANTE*/
          RPAD(C.NMCONTADOR,60,' ')                                                                    ||/*CONTADOR*/ 
          LPAD(CASE WHEN IDTPIJURCONT = 'J' THEN NRCPFRESPONS ELSE NRINSJURCONT END,11,' ')            ||/*CPF CONTADOR*/
          LPAD(C.NRCRCCONT2,15,' ')                                                                    ||/*CRC*/
          RPAD(C.SGESTADO,2,' ')                                                                       ||/*UF DO CRC*/
          LPAD(NVL(SUBSTR(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(C.NRTELCONTATO,'.',''),'-',''),'/',''),' ',''),')',''),'(',''),1,2),' '),4)||/*DDD*/
          LPAD(NVL(SUBSTR(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(C.NRTELCONTATO,'.',''),'-',''),'/',''),' ',''),')',''),'(',''),3,9),' '),9)||/*TELEFONE*/
          LPAD(NVL(C.NRRAMALCONTA,' '),5,' ')                                                          ||/*RAMAL*/
          LPAD(NVL(SUBSTR(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(C.NRFAXCONTATO,'.',''),'-',''),'/',''),' ',''),')',''),'(',''),1,2),' '),4)||/*DDD FAX*/
          LPAD(NVL(SUBSTR(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(REPLACE(C.NRFAXCONTATO,'.',''),'-',''),'/',''),' ',''),')',''),'(',''),3,9),' '),9)||/*FAX*/  
          RPAD(NVL(C.DSENDINTERN,' '),40,' ')                                                          ||/*CORREIO ELETRONICO*/
          RPAD(' ',10,' ')                                                                             )AS REG_R03/*BRANCOS*/
     INTO V_REG_R03
     FROM EMPRESA E, CONTADOR C, REPRESEMPRESA  R, REPRESLEGAL L
    WHERE E.CDEMPRESA   = P_CDEMPRESA
      AND E.CDCONTADOR2 = C.CDCONTADOR2
      AND E.CDEMPRESA   = R.CDEMPRESA
      AND R.IDATIVO     = 'S'
      and R.CDREPRES    = L.CDREPRES;
   V_CONTREGAR10 := NVL(V_CONTREGAR10,0)+1;
   INSERT INTO ARQMAGNETICO
      (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
      ('03'||LPAD(RTRIM(V_CONTREGAR10), 8, '0'), V_REG_R03, P_NRSEQARQMAG);

   RETURN V_CONTREGAR10;
 END;
/